// example class about a test
// hussein suleman
// 13 april 2009

// there are no comments because each paragraph print out an explanation
// that explains what the following lines of code do!

public class Mark
{
   public static void main ( String [] args )
   {
      System.out.println ("Test: different constructors to initialise objects");
      Test alfred = new Test ("Alfred");
      alfred.setMark (20);
      Test fazel = new Test ("Fazel", 10);

      System.out.println ("Test: using a method to access instance variables");
      alfred.printName();
      fazel.printName();

      System.out.println ("Test: using a method with a parameter (set to 1)");
      alfred.printBoth(1);
      fazel.printBoth(1);

      System.out.println ("Test: using a method with a parameter (set to 3)");
      alfred.printBoth(3);
      fazel.printBoth(3);
            
      System.out.println ("Test: using a method with a boolean return value");
      if (alfred.hasPassed ())
         System.out.println ("yay, " + alfred.getName());
      if (fazel.hasPassed ())
         System.out.println ("yay, " + fazel.getName());

      System.out.println ("Test: using a method with a parameter and a boolean return value");
      if (alfred.hasPassed2 (15))
         System.out.println ("yay, " + alfred.getName());
      if (fazel.hasPassed2 (15))
         System.out.println ("yay, " + fazel.getName());

      System.out.println ("Test: using a method with a parameter and an integer return value");
      if (alfred.getPercentage (30) >= 50)
         System.out.println ("yay, " + alfred.getName());
      if (fazel.getPercentage (30) >= 50)
         System.out.println ("yay, " + fazel.getName());

      System.out.println ("Test: using a method with a parameter and a String/Object return value");
      System.out.println (alfred.getWheeOrNoWhee (15));
      System.out.println (fazel.getWheeOrNoWhee (15));

      System.out.println ("Test: toString to convert object into String");
      System.out.println (alfred);
      System.out.println (fazel);      

      System.out.println ("Test: check static counter variable for number of objects created");
      System.out.println (Test.getCounter());      
      
      System.out.println ("Test: multiple references to an object");
      Test ref1 = alfred;
      Test ref2 = ref1;
      System.out.println (alfred.getName());
      System.out.println (ref1.getName());
      System.out.println (ref2.getName());
      
      System.out.println ("Test: changing an object with multiple references");
      alfred.resetBoth();
      System.out.println (alfred.getName());
      System.out.println (ref1.getName());
      System.out.println (ref2.getName()); 
   }   
}
